/**********************************************************************
  PNG[h
  $Id:$
**********************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include "tsp.h"
#include "png.h"

#define	RGB	0
#define	GRAY	1
#define	INDEXED	2

#define INVALID_TYPE 1

struct TSP_CHIP* load_png( unsigned char *file )
{
  int             i, j ;
  int             bpp ;		/* Bytes per pixel */
  int             num_passes ;	/* Number of interlace passes in file */
  int             pass ;		/* Current pass in file */
  FILE            *fp;		/* File pointer */
  png_structp     pp;		/* PNG read pointer */
  png_infop       info;		/* PNG info pointers */
  unsigned char	  *pixel_buf[2] ;
  unsigned char	  **pixels ;
  struct TSP_CHIP *chip ;

  
  chip=NULL ;
  
  if( (fp=fopen(file, "rb"))==NULL ){
    fprintf(stderr,"t@C %s I[vł܂\n",file) ;
    return( chip ) ;
  }
  
  pp   = png_create_read_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
  info = png_create_info_struct(pp);
  png_init_io( pp, fp );
  
  png_read_info( pp, info );
  if( info->bit_depth < 8 ){
    png_set_packing(pp);
    png_set_expand(pp);
    if( info->valid & PNG_INFO_sBIT ) png_set_shift(pp, &(info->sig_bit));
  }else{
    if( info->bit_depth == 16 ) png_set_strip_16(pp);
  }
  
  num_passes = png_set_interlace_handling(pp);

  switch( info->color_type ){
  case PNG_COLOR_TYPE_GRAY_ALPHA :	/* Grayscale + alpha */
  case PNG_COLOR_TYPE_RGB_ALPHA :	/* RGBA */
    bpp=4 ;
    break ;
  default :
    return( chip ) ;
  }
  
  pixel_buf[0] = malloc( info->width * bpp ) ;
  pixel_buf[1] = malloc( info->width * bpp ) ;
  chip=malloc(sizeof(struct TSP_CHIP)) ;

  if( pixel_buf[0]==NULL || pixel_buf[1]==NULL || chip==NULL ){
    goto LoadPNGExit ;
  }

  chip->map=malloc(sizeof(struct TSP_PIX) * info->width * info->height ) ;
  if( chip->map==NULL ){
    free( chip ) ;
    goto LoadPNGExit ;
  }
  chip->w=info->width  ;
  chip->h=info->height ;
  
  pixels = &pixel_buf[0] ;
  for( pass = 0 ; pass < num_passes ; pass++ ){
    for( j=0 ; j<info->height ; j++ ){
      png_read_rows( pp, pixels, NULL, 1 );
      for( i=0 ; i<info->width ; i++ ){
	chip->map[info->width*j+i].r=pixel_buf[0][i*bpp+0] ;
	chip->map[info->width*j+i].g=pixel_buf[0][i*bpp+1] ;
	chip->map[info->width*j+i].b=pixel_buf[0][i*bpp+2] ;
	chip->map[info->width*j+i].a=pixel_buf[0][i*bpp+3] ;
      }
    }
  }
  
  png_read_end(pp, info);

LoadPNGExit:
  png_destroy_read_struct(&pp, &info, NULL);
  
  free( pixel_buf[0] ) ;
  free( pixel_buf[1] ) ;
  fclose(fp);
  
  return( chip );
}
