/*
 *  TSPwb_
 *
 *  $Id:$
 */

struct TSP_PIX{
  unsigned char b,g,r,a ;
} ;

struct TSP_CHIP{
  int w ; /***  ***/
  int h ; /******/
  struct TSP_PIX *map ;
} ;

struct TSP_SP{
  int x , y ;
  int vx,vy ;
  int v , h ;
  int a     ;
  int pat   ;
} ;

struct TSP_PCG{
  struct TSP_CHIP **chip ;
  int             num    ;
  int             cur    ;
  struct TSP_SP   **sp   ;
  int             sp_max ;
  int             sp_cur ;
} ;

struct TSP_PCG tsp_pcg ;

struct TSP_WINDOW{
  int real_width ;
  int width ;
  int height ;
  struct TSP_PIX *vram ;
} ;

#define TSP_PCG_INIT_ERROR          -1
#define TSP_SP_INIT_ERROR           -2
#define TSP_PCG_AREA_FULL           -3
#define TSP_MALLOC_ERROR            -4
#define TSP_INVALID_WINDOW_ERROR    -5
#define TSP_SP_AREA_FULL            -6
#define TSP_NULL_PAT                -7

struct TSP_WINDOW* init_window() ;
int al_vram( struct TSP_WINDOW *win ) ;

int init_pcg( int pcg_num ) ;
int init_sp( int sp_num ) ;

int add_pcg( struct TSP_CHIP *chip ) ;
int set_sp( struct TSP_SP *sp ) ;
int draw_sp( struct TSP_WINDOW *win ) ;

struct TSP_CHIP* load_png( unsigned char *file ) ;
